--##############################################################################
--
-- SAMPLE SCRIPTS TO ACCOMPANY "SQL SERVER 2017 ADMINISTRATION INSIDE OUT"
--
-- © 2018 MICROSOFT PRESS
--
--##############################################################################
--
-- CHAPTER 6: ADMINISTERING SECURITY AND PERMISSIONS
-- T-SQL SAMPLE 10
--
SELECT DISTINCT
	SERVER_ROLE_NAME = QUOTENAME(R.NAME) 
	, ROLE_TYPE = R.TYPE_DESC
	, PRINCIPAL_NAME = QUOTENAME(M.NAME)
	, PRINCIPAL_TYPE = M.TYPE_DESC 
	, SQL2008R2_BELOW_CREATETSQL = 'SP_ADDSRVROLEMEMBER @LOGINAME= ''' + M.NAME + ''', @ROLENAME = ''' + R.NAME + '''' 
	, SQL2012_ABOVE_CREATETSQL = 'ALTER SERVER ROLE [' + R.NAME + '] ADD MEMBER [' + M.NAME + ']'
FROM SYS.SERVER_ROLE_MEMBERS AS RM
	INNER JOIN SYS.SERVER_PRINCIPALS R ON RM.ROLE_PRINCIPAL_ID = R.PRINCIPAL_ID
	INNER JOIN SYS.SERVER_PRINCIPALS M ON RM.MEMBER_PRINCIPAL_ID = M.PRINCIPAL_ID
WHERE 
	-- IGNORE DISABLED ACCOUNTS
	R.IS_DISABLED = 0 AND M.IS_DISABLED = 0  
	-- IGNORE BUILT-IN ACCOUNTS
	AND M.NAME NOT IN ('DBO', 'SA') 
ORDER BY QUOTENAME(R.NAME);